import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Lab #6 CS 2334, Section SECTION NUMBER GOES HERE DATE GOES HERE
 * <p>
 * The MVC controller for the program.
 * </p>
 * 
 * @version 1.0
 * 
 */
public class AcademicPapersController {
	private AcademicPapersModel model;
	private AcademicPapersInputWindow inputView;

	/**
	 * Creates new AcademicPaperController
	 */
	public AcademicPapersController() {
		// intentionally empty
	}

	/**
	 * @param model to set as the model
	 */
	public void setModel(AcademicPapersModel model) {
		this.model = model;
	}

	/**
	 * @return model
	 */
	public AcademicPapersModel getModel() { // future use
		return model;
	}
	
	/**
	 * AddAcademicPaperListener provides a method to create a new academic paper. 
	 * The academic paper should then be added to the academic paper list of the
	 * model. The values for the new academic paper come from the fields of the 
	 * inputView. If the model is null when the method is called, it returns 
	 * without taking any action.
	 */
	private class AddAcademicPaperListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (model == null) return;  // No model associated.  Can't do anything.

			String title = inputView.jtfTitle.getText();
			String authorNames = inputView.jtfAuthorNames.getText();
			String serialTitle = inputView.jtfSerialTitle.getText();
			String paperType = (String)inputView.jcbPaperType.getSelectedItem();
			String publicationDate = inputView.jtfPublicationDate.getText();
			
			
			if (model.contains(title)) {  // Academic paper already in collection so ask what to do

				// TODO: Use a JOptionPane here to ask what to do 
				int response = 2;  // assign returned value of JOptionPane to response

				if (response == 0) {
					// option 0 is cancel so do nothing
				}
				else if (response == 1) {
					// TODO: call mutator method to replace academic paper
					// (note that option 1 should be replace)
				}
				else if (response == 2) {
					// TODO: call mutator method to add an author to the academic paper 
					// (option 2 should be add to records)
				}
				else {
					// Should handle error case here (we won't for this lab).
				}
			}
			else {  // Academic paper not in collection, so add it.
				
			}
		}
	}

	/**
	 * ClearAcademicPapersListener provides a method to clear the academic paper 
	 * list of the model. If the model is null when the method is called, it 
	 * returns without taking any action.
	 */
	private class ClearAcademicPapersListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (model == null) return;  // No model associated.  Can't do anything.
			model.clearAcademicPapers();
		}
	}

	/**
	 * ClearInputFieldsListener provides a method to clear the input fields of
	 * the inputView.
	 */
	private class ClearInputFieldsListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			inputView.clearInputFields();
		}
	}

	
	
	// TODO:  Create additional listener classes for menu and toolbar.
	
	
	
	


	/**
	 * @param theView on which the listeners should be set
	 */
	public void setInputWindow(AcademicPapersInputWindow theView) {
		inputView = theView;

		// Register listeners
		inputView.getAddAcademicPaperButton().addActionListener(new AddAcademicPaperListener());
		inputView.getClearInputButton().addActionListener(new ClearInputFieldsListener());
		inputView.getClearAcademicPapersButton().addActionListener(new ClearAcademicPapersListener());

		// TODO: Register additional listeners for menu and toolbar.


		System.out.println("listeners registered in controller for input window");
	}

	/**
	 * @return the window (in case it needs to be sent messages from elsewhere)
	 */
	public AcademicPapersInputWindow getInputWindow() { // future use
		return inputView;
	}
}